"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
exports.__esModule = true;
var riteway_1 = require("riteway");
var src_1 = require("../src");
var errors = require("../src/errors");
riteway_1.describe('asciiToTrytes(ascii)', function (assert) { return __awaiter(_this, void 0, void 0, function () {
    return __generator(this, function (_a) {
        assert({
            given: 'ascii',
            should: 'convert to trytes',
            actual: src_1.asciiToTrytes('IOTA'),
            expected: 'SBYBCCKB'
        });
        assert({
            given: 'utf8 as input',
            should: 'throw error',
            actual: riteway_1.Try(src_1.asciiToTrytes, 'Γιώτα'),
            expected: new Error(errors.INVALID_ASCII_CHARS)
        });
        return [2 /*return*/];
    });
}); });
riteway_1.describe('trytesToAscii(trytes)', function (assert) { return __awaiter(_this, void 0, void 0, function () {
    return __generator(this, function (_a) {
        assert({
            given: 'tryte-encoded ascii',
            should: 'convert to ascii',
            actual: src_1.trytesToAscii('SBYBCCKB'),
            expected: 'IOTA'
        });
        assert({
            given: 'tryte-encoded ascii with 9s',
            should: 'convert to ascii ignoring zero/null char code',
            actual: src_1.trytesToAscii('SBYBCCKB9999'),
            expected: 'IOTA'
        });
        assert({
            given: 'non-trytes',
            should: 'throw error',
            actual: riteway_1.Try(src_1.trytesToTrits, 'AAfasds'),
            expected: new Error(errors.INVALID_TRYTES)
        });
        assert({
            given: 'trytes of odd length',
            should: 'throw error',
            actual: riteway_1.Try(src_1.trytesToAscii, 'AAA'),
            expected: new Error(errors.INVALID_ODD_LENGTH)
        });
        return [2 /*return*/];
    });
}); });
riteway_1.describe('tritsToTrytes(trytesToTrits(trytes))', function (assert) { return __awaiter(_this, void 0, void 0, function () {
    return __generator(this, function (_a) {
        assert({
            given: 'trytes',
            should: 'convert to trits and back',
            actual: src_1.tritsToTrytes(src_1.trytesToTrits('IOTA')),
            expected: 'IOTA'
        });
        return [2 /*return*/];
    });
}); });
riteway_1.describe('tritsToValue(valueToTrits(value))', function (assert) { return __awaiter(_this, void 0, void 0, function () {
    return __generator(this, function (_a) {
        assert({
            given: 'value',
            should: 'convert to trits and back',
            actual: src_1.tritsToValue(src_1.valueToTrits(999999)),
            expected: 999999
        });
        return [2 /*return*/];
    });
}); });
//# sourceMappingURL=converter.test.js.map