"use strict";
exports.__esModule = true;
var ava_1 = require("ava");
var src_1 = require("../src");
ava_1["default"]('padTag() adds correct padding to tag.', function (t) {
    var tag = 'IOTA';
    var expected = 'IOTA' + '9'.repeat(23);
    t.is(src_1.padTag(tag), expected, 'padTag() should add correct padding to tag.');
});
ava_1["default"]('padTag() adds no padding to 27-trytes long tags.', function (t) {
    var tag = 'TAG'.repeat(9);
    t.is(src_1.padTag(tag), tag, 'padTag() should add no padding to 27-trytes long tags.');
});
ava_1["default"]('padTagArray() adds correct padding to tag array.', function (t) {
    var tags = ['IOTA'];
    var expected = ['IOTA' + '9'.repeat(23)];
    t.deepEqual(src_1.padTagArray(tags), expected, 'padTag() should add correct padding to tag array.');
});
//# sourceMappingURL=padTag.test.js.map