"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
exports.__esModule = true;
var ava_1 = require("ava");
var src_1 = require("../src");
ava_1["default"]('isInput()', function (t) {
    var address = 'JALLWDUOSTSJVL9EEHKW9YQFPBVBJAGLNKRVGSQZCGHQWEMIIILJMTHVAGVDXJVZMBAMOZTSBQNRVNLLS';
    var validInput = {
        address: address,
        security: 2,
        keyIndex: 0,
        balance: 10
    };
    t.is(src_1.isInput(validInput), true, 'isInput returns true for valid input');
    t.is(src_1.isInput({
        address: address,
        keyIndex: 0,
        balance: 10
    }), false, 'isInput returns false for input without security level');
    t.is(src_1.isInput({
        address: address,
        keyIndex: 0,
        security: 2
    }), true, 'isInput returns true for valid input without balance');
    t.is(src_1.isInput(__assign({}, validInput, { address: 'dsafas' })), false, 'isInput returns false for input with invalid address');
    t.is(src_1.isInput(__assign({}, validInput, { address: undefined })), false, 'isInput returns false for input without address');
    t.is(src_1.isInput(__assign({}, validInput, { security: -1.5 })), false, 'isInput returns false for input with invalid security');
    t.is(src_1.isInput(__assign({}, validInput, { keyIndex: -1 })), false, 'isInput returns false for input with invalid keyIndex');
    t.is(src_1.isInput(__assign({}, validInput, { keyIndex: undefined })), false, 'isInput returns false for input without keyIndex');
    t.is(src_1.isInput(__assign({}, validInput, { balance: -10 })), false, 'isInput returns false for invalid balance');
});
//# sourceMappingURL=isInput.test.js.map