"use strict";
exports.__esModule = true;
var ava_1 = require("ava");
var src_1 = require("../src");
ava_1["default"]('isTransferArray() returns true for valid transfer.', function (t) {
    var transfers = [
        {
            address: 'JALLWDUOSTSJVL9EEHKW9YQFPBVBJAGLNKRVGSQZCGHQWEMIIILJMTHVAGVDXJVZMBAMOZTSBQNRVNLLSJMPIVGPNE',
            value: 1234,
            message: 'AFDSA',
            tag: 'ASDFDSAFDFDSA'
        },
    ];
    t.is(src_1.isTransferArray(transfers), true, 'isTransferArray() should return true for valid transfer.');
});
ava_1["default"]('isTransferArray() returns false for transfer with invalid address.', function (t) {
    var transfers = [
        {
            address: 'JALLWDUOSTSJVL9EEHKW9YQFPBVBJAGLNKRVGSQZCGHQWEMIIILJMTHVAGVDXJVZMBAMOZTSBQNRVNLLSJMPIVGPNEFSAF',
            value: 1234,
            message: 'AFDSA',
            tag: 'ASDFDSAFDFDSA'
        },
    ];
    t.is(src_1.isTransferArray(transfers), false, 'isTransferArray() should return false for transfer with invalid address.');
});
ava_1["default"]('isTransferArray() returns false for transfer with invalid value.', function (t) {
    var transfers = [
        {
            address: 'JALLWDUOSTSJVL9EEHKW9YQFPBVBJAGLNKRVGSQZCGHQWEMIIILJMTHVAGVDXJVZMBAMOZTSBQNRVNLLSJMPIVGPNE',
            value: -10,
            message: 'AFDSA',
            tag: 'ASDFDSAFDFDSA'
        },
    ];
    t.is(src_1.isTransferArray(transfers), false, 'isTransferArray() should return false for transfer with invalid value.');
});
ava_1["default"]('isTransferArray() returns false for message of invalid trytes.', function (t) {
    var transfers = [
        {
            address: 'JALLWDUOSTSJVL9EEHKW9YQFPBVBJAGLNKRVGSQZCGHQWEMIIILJMTHVAGVDXJVZMBAMOZTSBQNRVNLLSJMPIVGPNE',
            value: 1234,
            message: 'dffsA',
            tag: 'ASDFDSAFDFDSA'
        },
    ];
    t.is(src_1.isTransferArray(transfers), false, 'isTransferArray() should return false for message of invalid trytes.');
});
ava_1["default"]('isTransferArray() returns false for tag of invalid length.', function (t) {
    var transfers = [
        {
            address: 'JALLWDUOSTSJVL9EEHKW9YQFPBVBJAGLNKRVGSQZCGHQWEMIIILJMTHVAGVDXJVZMBAMOZTSBQNRVNLLSJMPIVGPNE',
            value: 1234,
            message: 'AFDSA',
            tag: 'ASDFDSAFDFDSAASFSDFSDFSDFSDF'
        },
    ];
    t.is(src_1.isTransferArray(transfers), false, 'isTransferArray() should return false for tag of invalid length.');
});
ava_1["default"]('isTransferArray() returns false for tag of invalid trytes.', function (t) {
    var transfers = [
        {
            address: 'JALLWDUOSTSJVL9EEHKW9YQFPBVBJAGLNKRVGSQZCGHQWEMIIILJMTHVAGVDXJVZMBAMOZTSBQNRVNLLSJMPIVGPNE',
            value: 1234,
            message: 'AFDSA',
            tag: 'sdfASDF'
        },
    ];
    t.is(src_1.isTransferArray(transfers), false, 'isTransferArray() should return false for tag of invalid trytes.');
});
//# sourceMappingURL=isTransferArray.test.js.map