"use strict";
exports.__esModule = true;
var ava_1 = require("ava");
var src_1 = require("../src");
ava_1["default"]('isTrytes() returns true for valid trytes.', function (t) {
    var validTrytes = 'JALLWDUOSTSJVL9EEHKW9YQFPBVBJAGLNKRVGSQZCGHQWEMIIILJMTHVAGVDXJVZMBAMOZTSBQNRVNLLS';
    t.is(src_1.isTrytes(validTrytes), true, 'isTrytes() should return true for valid trytes.');
});
ava_1["default"]('isTrytes() returns true for valid trytes and length.', function (t) {
    var trytes = 'ABCDEFGHI';
    t.is(src_1.isTrytes(trytes, 9), true, 'isTrytes() should return true for valid trytes and valid length.');
});
ava_1["default"]('isTrytes() returns false for trytes of invalid length.', function (t) {
    var trytes = 'ABCDEFGHI';
    t.is(src_1.isTrytes(trytes, 10), false, 'isTrytes() should return false for trytes of invalid length.');
});
ava_1["default"]('isTrytes() returns false for invalid trytes.', function (t) {
    var invalidTrytes = '134asdfLWDUOSTSJVL9EEHKW9YQFPBVBJAGLNKRVGSQZCGHQWEMIIILJMTHVAGVDXJVZMBAMOZTSBQNRVNLLASD';
    t.is(src_1.isTrytes(invalidTrytes), false, 'isTrytes() should return false for invalid trytes.');
});
//# sourceMappingURL=isTrytes.test.js.map