"use strict";
exports.__esModule = true;
var ava_1 = require("ava");
var src_1 = require("../src");
ava_1["default"]('isTrytes() returns true for valid trytes of exact length.', function (t) {
    var validTrytes = 'JALLWDUOSTSJVL9EEHKW9YQFPBVBJAGLNKRVGSQZCGHQWEMIIILJMTHVAGVDXJVZMBAMOZTSBQNRVNLL';
    t.is(src_1.isTrytesOfExactLength(validTrytes, 80), true, 'isTrytes() should return true for valid trytes of exact length.');
});
ava_1["default"]('isTrytes() returns false for trytes of invalid length.', function (t) {
    var trytes = 'ABCDEFGHI';
    t.is(src_1.isTrytesOfExactLength(trytes, 10), false, 'isTrytes() should return false for trytes of invalid length.');
});
ava_1["default"]('isTrytes() returns false for invalid trytes.', function (t) {
    var invalidTrytes = 'ab13DEFGHI';
    t.is(src_1.isTrytesOfExactLength(invalidTrytes, 10), false, 'isTrytes() should return false for invalid trytes.');
});
//# sourceMappingURL=isTrytesOfExactLength.test.js.map