"use strict";
exports.__esModule = true;
var ava_1 = require("ava");
var src_1 = require("../src");
ava_1["default"]('isTrytesOfMaxLength() returns true for valid trytes and length.', function (t) {
    var validTrytes = 'JALLWDUOSTSJVL9EEHKW9YQFPBVBJAGLNKRVGSQZCGHQWEMIIILJMTHVAGVDXJVZMBAMOZTSBQNRVNLLS';
    t.is(src_1.isTrytesOfMaxLength(validTrytes, 81), true, 'isTrytesOfMaxLength() should return true for valid trytes and length.');
    t.is(src_1.isTrytesOfMaxLength('DASFASDF', 81), true, 'isTrytesOfMaxLength() should return true for valid trytes and length.');
});
ava_1["default"]('isTrytesOfMaxLength() returns false for trytes of invalid length.', function (t) {
    var trytes = 'ABCDEFGHI';
    t.is(src_1.isTrytesOfMaxLength(trytes, 8), false, 'isTrytesOfMaxLength() should return false for trytes of invalid length.');
});
ava_1["default"]('isTrytesOfMaxLength() returns false for invalid trytes.', function (t) {
    var invalidTrytes = '134asdfLWDUOSTSJVL9EEHKW9YQFPBVBJAGLNKRVGSQZCGHQWEMIIILJMTHVAGVDXJVZMBAMOZTSBQNRVNLLASD';
    t.is(src_1.isTrytesOfMaxLength(invalidTrytes, 87), false, 'isTrytesOfMaxLength() should return false for invalid trytes.');
});
//# sourceMappingURL=isTrytesOfMaxLength.test.js.map